package svc

import (
	"applet/app/db"
	"applet/app/md"
	"applet/app/utils/cache"
	"code.fnuoos.com/EggPlanet/egg_models.git/src/model"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_mq.git/rabbit"
	"fmt"
	"time"
	"xorm.io/xorm"
)

func NoLoginSend(eg *xorm.Engine) {
	PessimismLockValue := "NoLoginSend"
	ch, err := rabbit.Cfg.Pool.GetChannel()
	if err != nil {
		return
	}
	defer ch.Release()
	key := fmt.Sprintf("NoLoginSend")
	//TODO::增加“悲观锁”防止串行
	getString, _ := cache.GetString(key)
	if getString == PessimismLockValue {
		fmt.Println("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!", "上一次未执行完")
		return
	}
	cache.SetEx(key, PessimismLockValue, 3600*8) //8小时
	notice := make([]model.JpushNotice, 0)
	eg.Where("type='login' and is_show=1").Desc("day").Find(&notice)
	sms := make([]model.AliyunSmsNotice, 0)
	eg.Where("type='login' and is_show=1").Desc("day").Find(&sms)

	//tmp := make(map[string]map[string]string)
	//for _,v:=range notice{
	//
	//}

	now := time.Now().Unix()
	for _, v := range notice {
		commNoLoginSend(eg, ch, 1, v.Title, v.Content, time.Unix(now-int64(v.Day)*3600, 0).Format("2006-01-02 15:04:05"), time.Unix(now-int64(v.NoticeDay)*3600, 0).Format("2006-01-02 15:04:05"))
	}
	cache.Del(key)
}
func commNoLoginSend(eg *xorm.Engine, ch *rabbit.Channel, p int, title, content, lastLoginAt, loginNoticeTime string) {
	sql := `
SELECT u.id,u.phone,unt.id as unt_id FROM user u
LEFT JOIN user_notice_time unt on u.id=unt.uid
WHERE u.last_login_at<'%s' and unt.login_notice_time<'%s'
`
	sql = fmt.Sprintf(sql, lastLoginAt, loginNoticeTime)
	userList, _ := db.QueryNativeString(eg, sql)
	uids := ""
	phones := ""
	if len(userList) == 0 {
		return
	}
	//TODO
	extra := "{\"content\":\"" + "" + "\"}"
	for _, v := range userList {
		if uids == "" {
			phones += v["phone"]
			uids += v["id"]
		} else {
			phones += "," + v["phone"]
			uids += "," + v["id"]
		}
		eg.Where("id=?", v["unt_id"]).Cols("login_notice_time").Update(&model.UserNoticeTime{LoginNoticeTime: time.Now()})
	}
	if uids == "" && phones == "" {
		return
	}
	if uids != "" {
		//TODO 替换数据
		arg := md.JpushRecordFundData{UserId: uids, Target: "1", Platform: "all", Title: title, Content: content}
		err := ch.PublishV2(md.EggJpushRecordQueueExchange, arg, md.EggJpushRecordQueue)
		if err != nil {
			ch.PublishV2(md.EggJpushRecordQueueExchange, arg, md.EggJpushRecordQueue)
		}
	}
	if phones != "" {
		arg := md.AliyunSmsRecordFundData{Phone: phones, Title: title, Content: content, Code: content, Extra: extra}
		err := ch.PublishV2(md.EggAliyunSmsRecordQueueExchange, arg, md.EggAliyunSmsRecordQueue)
		if err != nil {
			ch.PublishV2(md.EggAliyunSmsRecordQueueExchange, arg, md.EggAliyunSmsRecordQueue)
		}
	}
	if len(userList) == 1000 {
		p++
		commNoLoginSend(eg, ch, p, title, content, lastLoginAt, loginNoticeTime)
		return
	}
	return

}
